package oop.demo4;

import java.util.Vector;
import javax.microedition.lcdui.Alert;
import javax.microedition.lcdui.Canvas;
import javax.microedition.lcdui.Font;
import javax.microedition.lcdui.Graphics;
import oop.Demo;

/**
 * @author aNNiMON
 */
public class Menu {
    
    public static final Font ITEM_FONT = Font.getFont(Font.FACE_SYSTEM, Font.STYLE_PLAIN, Font.SIZE_MEDIUM);
    public static final int ITEM_HEIGHT = ITEM_FONT.getHeight();

    private int cursor;
    private Vector items;

    public Menu() {
        cursor = 0;
        items = new Vector();
    }
    
    public void addMenuItem(String name) {
        items.addElement( new MenuItem(name) );
    }
    
    public void addMenuItem(String name, int color) {
        items.addElement( new ColorMenuItem(name, color) );
    }
    
    public void addMenuItem(String name, String iconName) {
        items.addElement( new IconMenuItem(name, iconName) );
    }
    
    public void paint(Graphics g) {
        g.setFont(ITEM_FONT);
        g.setColor(0xFF095E15);
        final int size = items.size();
        final int startY = g.getClipHeight() - ITEM_HEIGHT * size;
        for (int i = 0; i < size; i++) {
            getMenuItem(i).paint(g, startY, i);
        }
        // Draw cursor
        g.setColor(0xFF11C62A);
        g.drawRect(0, startY + ITEM_HEIGHT * cursor, g.getClipWidth(), ITEM_HEIGHT);
    }
    
    public void handleKeys(int gameActionKey) {
        switch (gameActionKey) {
            case Canvas.UP:
                cursor--;
                if (cursor < 0) cursor = items.size() - 1;
                break;
            case Canvas.DOWN:
                cursor++;
                if (cursor >= items.size()) cursor = 0;
                break;
            case Canvas.FIRE:
                Alert al = new Alert("Info");
                al.setString(getMenuItem(cursor).getName() + "\n" + getMenuItem(cursor).getClass().getName());
                Demo.midlet.dsp.setCurrent(al);
                break;
        }
    }
    
    private MenuItem getMenuItem(int index) {
        return (MenuItem) items.elementAt(index);
    }
}